Subject: Re: [PATCH bpf-next V2 0/7] xdp: Allow BPF to set RX hints for XDP_REDIRECTed packets

From: Jakub Kicinski <[email-masked]>
Date: Tue, 5 Aug 2025 16:54:14 -0700

On Tue, 5 Aug 2025 15:18:52 +0200 Lorenzo Bianconi wrote:
> > I was thinking of doing the SET on the veth side. Basically the
> > metadata has to be understood by the stack only at the xdp->skb
> > transition point. So we can delay the SET until that moment, carrying
> > the information in program-specific format.  
> 
> ack, I am fine to delay the translation of the HW metadata from a HW
> specific format (the one contained in the DMA descriptor) to the network one
> when they are consumed to create the SKB (the veth driver in this case) but I
> guess we need to copy the info contained in the DMA descriptor into a buffer
> that is still valid when veth driver consumes them since the DMA descriptor
> can be no longer available at that time. Do you agree or am I missing
> something?

That's right, we need to carry the metadata we need with the packet
(in an XDP program-specific md prepend, presumably).